<template>

	<v-card>
        <v-card-title>
			User Profile
		</v-card-title>

        <v-card-text>

			<v-form
				ref="form"
				v-model="valid"
				lazy-validation>

				<v-text-field
					v-model="name"
					:counter="50"
					:rules="nameRules"
					label="Full Name"
					required>
				</v-text-field>

				<v-text-field
					v-model="email"					
					label="E-mail"
					disabled>
				</v-text-field>

				<v-text-field
					v-model="email_verification"					
					label="Email Verification At"
					disabled>
				</v-text-field>

				<v-text-field
					v-model="role"				
					label="Assigned Role"
					disabled>
				</v-text-field>

				<v-file-input					
					v-on:change="absorbImage(files,$event)"
					:rules="imageRules"
					accept="image/png, image/jpeg, image/bmp"
					placeholder="Pick an avatar"
					prepend-icon="mdi-camera"
					label="Avatar Image"
				></v-file-input>

				<v-btn
					:disabled="!valid"
					color="success"
					class="mr-4"
					@click="validate">
					Update
				</v-btn>

				<v-btn
					color="error"
					class="mr-4"
					@click="reset">
					Reset
				</v-btn>

				<alert/>

			</v-form>

        </v-card-text>
        
    </v-card>
  	
</template>

<script>
import alert from '../../../components/Alert.vue'
import {mapGetters, mapActions} from 'vuex'

export default {
	components:{
		alert
	},
	data:function(){
		return{
			valid: true,
			name: '',
			nameRules: [
				v => !!v || 'Name is required',
				v => (v && v.length <= 50) || 'Name must be less than 50 characters',
			],
			email: '',			
			email_verification: '',
			image: [],
			imageRules: [
				value => !value || value.size < 2000000 || 'Avatar size should be less than 2 MB!',
      		],
			role: '',			
			files:[]  		
		}
	},methods:{
		async submit(){
			try {
				
				console.log('submit update with image')
				
				let response = await axios.post('/api/profile/update-profile', this.createUpdateForm(),this.headers())
				 
				let {response_message, response_code} = response.data

				if(response.status == 200){
					
					this.show({
						title:'success',
						message:response_message,						
					})

				}else{

					this.show({
						title:'error',
						message:response_message,						
					})

				}
			} catch (e) {

				console.log(e);

				let {message, errors} = e.response.data
				this.theErrors = errors
				
				console.log('Error is comming');
				console.log(errors);
				
				this.show({
						title:'error',
						message:message,
						theErrors:errors						
				})

			}
		},
		async getProfileData(){
			try {
				let response = await axios.get('/api/profile/get-profile',this.headers())

				let {response_code, response_message} = response.data

				if( response.status == '200' ){

					if(response_code=='00'){
						
						let{profile} = response.data.data

						console.log(profile)
						
						this.name = profile.full_name
						this.email = profile.email
						this.image = profile.image
						this.email_verification = profile.email_verification 
						this.role = profile.role

					}else{

						this.show({
							title:'error',
							message:response_message,													
						})

					}
				}else{
					
					this.show({
							title:'error',
							message:response_message,													
					})

				}

			} catch (e) {
				
				console.log(e);	

				let {errors, message} = e.response.data
				
				this.show({
					title:'error',
					message:message,
					theErrors:errors													
				})

			}
			
		},
		validate:function () {
			let isSuccessfullyValidated = this.$refs.form.validate()
			if(isSuccessfullyValidated){
				console.log(`the input parameter are: ${this.name} & ${this.image}`)
				this.submit()
			}else{
				console.log(`the problematic input parameter are: ${this.name} & ${this.image}`)

				this.message = 'Your input is not valid!'
				this.snackbar = true
				this.color = 'red'
			}
			
		},
		reset:function () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},
		createUpdateForm:function(){

			let data = new FormData();
			data.append('image',this.image)
			data.append('name',this.name) 

			return data

		},
		headers:function(){
			return{
				headers :{

					'Accept': 'application/json',
					'Access-Control-Allow-Headers': 'Authorization',
					Authorization:`Bearer ${this.getKey()}`,			
										
				}
			}
		},absorbImage:function(files, event){
			
			console.log('File has been detected')
			
			console.log(event)

			this.image = event
			
		},
		...mapGetters({
			getKey:'authenticate/haveToken',
		}),
		...mapActions({
			show:'alert/show'
		})		

	},mounted: function(){

		console.log('View Profile Screen Mounted')

	},created: function(){

		console.log('View Profile Screen Created')
		this.getProfileData()

	}
}
</script>

<style>

</style>